'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dataStatisticsFrequencyMetrics = require('./data-statistics-frequencyMetrics');

var _dataStatisticsFrequencyMetrics2 = _interopRequireDefault(_dataStatisticsFrequencyMetrics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * simple mask analysis, computes mask on every element and create frequency analysis of the masks
 */

var MaskAnalysis = function (_FrequencyMetrics) {
    _inherits(MaskAnalysis, _FrequencyMetrics);

    function MaskAnalysis() {
        var options = arguments.length <= 0 || arguments[0] === undefined ? { elements: [] } : arguments[0];

        _classCallCheck(this, MaskAnalysis);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(MaskAnalysis).call(this, options));

        _this._constructDiaMap();
        _this.letter = new RegExp('[A-Za-z]', 'g');
        _this.digit = new RegExp('\\d', 'g');
        return _this;
    }

    _createClass(MaskAnalysis, [{
        key: 'updateStatistics',
        value: function updateStatistics(elements) {
            this.updateFrequencies(this.convertToMasks(elements));
        }
    }, {
        key: 'convertToMasks',
        value: function convertToMasks(elements) {
            var _this2 = this;

            return elements.map(function (elem) {
                if (elem.value != null) {
                    return { value: _this2.removeDiacritics(elem.value).replace(_this2.letter, 'L').replace(_this2.digit, 'D') };
                } else {
                    return "NULL";
                }
            }, this);
        }

        // "what?" version ... http://jsperf.com/diacritics/12

    }, {
        key: 'removeDiacritics',
        value: function removeDiacritics(str) {
            var _this3 = this;

            str = str.toString();
            return str.replace(/[^\u0000-\u007E]/g, function (a) {
                return _this3.diacriticsMap[a] || a;
            });
        }

        //construct diacritics removal map. Thanks to this guy, god bless his soul: http://jsperf.com/diacritics/12

    }, {
        key: '_constructDiaMap',
        value: function _constructDiaMap() {
            var defaultDiacriticsRemovalap = [{ 'base': 'A', 'letters': 'AⒶＡÀÁÂẦẤẪẨÃĀĂẰẮẴẲȦǠÄǞẢÅǺǍȀȂẠẬẶḀĄȺⱯ' }, { 'base': 'AA', 'letters': 'Ꜳ' }, { 'base': 'AE', 'letters': 'ÆǼǢ' }, { 'base': 'AO', 'letters': 'Ꜵ' }, { 'base': 'AU', 'letters': 'Ꜷ' }, { 'base': 'AV', 'letters': 'ꜸꜺ' }, { 'base': 'AY', 'letters': 'Ꜽ' }, { 'base': 'B', 'letters': 'BⒷＢḂḄḆɃƂƁ' }, { 'base': 'C', 'letters': 'CⒸＣĆĈĊČÇḈƇȻꜾ' }, { 'base': 'D', 'letters': 'DⒹＤḊĎḌḐḒḎĐƋƊƉꝹ' }, { 'base': 'DZ', 'letters': 'ǱǄ' }, { 'base': 'Dz', 'letters': 'ǲǅ' }, { 'base': 'E', 'letters': 'EⒺＥÈÉÊỀẾỄỂẼĒḔḖĔĖËẺĚȄȆẸỆȨḜĘḘḚƐƎ' }, { 'base': 'F', 'letters': 'FⒻＦḞƑꝻ' }, { 'base': 'G', 'letters': 'GⒼＧǴĜḠĞĠǦĢǤƓꞠꝽꝾ' }, { 'base': 'H', 'letters': 'HⒽＨĤḢḦȞḤḨḪĦⱧⱵꞍ' }, { 'base': 'I', 'letters': 'IⒾＩÌÍÎĨĪĬİÏḮỈǏȈȊỊĮḬƗ' }, { 'base': 'J', 'letters': 'JⒿＪĴɈ' }, { 'base': 'K', 'letters': 'KⓀＫḰǨḲĶḴƘⱩꝀꝂꝄꞢ' }, { 'base': 'L', 'letters': 'LⓁＬĿĹĽḶḸĻḼḺŁȽⱢⱠꝈꝆꞀ' }, { 'base': 'LJ', 'letters': 'Ǉ' }, { 'base': 'Lj', 'letters': 'ǈ' }, { 'base': 'M', 'letters': 'MⓂＭḾṀṂⱮƜ' }, { 'base': 'N', 'letters': 'NⓃＮǸŃÑṄŇṆŅṊṈȠƝꞐꞤ' }, { 'base': 'NJ', 'letters': 'Ǌ' }, { 'base': 'Nj', 'letters': 'ǋ' }, { 'base': 'O', 'letters': 'OⓄＯÒÓÔỒỐỖỔÕṌȬṎŌṐṒŎȮȰÖȪỎŐǑȌȎƠỜỚỠỞỢỌỘǪǬØǾƆƟꝊꝌ' }, { 'base': 'OI', 'letters': 'Ƣ' }, { 'base': 'OO', 'letters': 'Ꝏ' }, { 'base': 'OU', 'letters': 'Ȣ' }, { 'base': 'OE', 'letters': 'Œ' }, { 'base': 'oe', 'letters': 'œ' }, { 'base': 'P', 'letters': 'PⓅＰṔṖƤⱣꝐꝒꝔ' }, { 'base': 'Q', 'letters': 'QⓆＱꝖꝘɊ' }, { 'base': 'R', 'letters': 'RⓇＲŔṘŘȐȒṚṜŖṞɌⱤꝚꞦꞂ' }, { 'base': 'S', 'letters': 'SⓈＳẞŚṤŜṠŠṦṢṨȘŞⱾꞨꞄ' }, { 'base': 'T', 'letters': 'TⓉＴṪŤṬȚŢṰṮŦƬƮȾꞆ' }, { 'base': 'TZ', 'letters': 'Ꜩ' }, { 'base': 'U', 'letters': 'UⓊＵÙÚÛŨṸŪṺŬÜǛǗǕǙỦŮŰǓȔȖƯỪỨỮỬỰỤṲŲṶṴɄ' }, { 'base': 'V', 'letters': 'VⓋＶṼṾƲꝞɅ' }, { 'base': 'VY', 'letters': 'Ꝡ' }, { 'base': 'W', 'letters': 'WⓌＷẀẂŴẆẄẈⱲ' }, { 'base': 'X', 'letters': 'XⓍＸẊẌ' }, { 'base': 'Y', 'letters': 'YⓎＹỲÝŶỸȲẎŸỶỴƳɎỾ' }, { 'base': 'Z', 'letters': 'ZⓏＺŹẐŻŽẒẔƵȤⱿⱫꝢ' }, { 'base': 'a', 'letters': 'aⓐａẚàáâầấẫẩãāăằắẵẳȧǡäǟảåǻǎȁȃạậặḁąⱥɐ' }, { 'base': 'aa', 'letters': 'ꜳ' }, { 'base': 'ae', 'letters': 'æǽǣ' }, { 'base': 'ao', 'letters': 'ꜵ' }, { 'base': 'au', 'letters': 'ꜷ' }, { 'base': 'av', 'letters': 'ꜹꜻ' }, { 'base': 'ay', 'letters': 'ꜽ' }, { 'base': 'b', 'letters': 'bⓑｂḃḅḇƀƃɓ' }, { 'base': 'c', 'letters': 'cⓒｃćĉċčçḉƈȼꜿↄ' }, { 'base': 'd', 'letters': 'dⓓｄḋďḍḑḓḏđƌɖɗꝺ' }, { 'base': 'dz', 'letters': 'ǳǆ' }, { 'base': 'e', 'letters': 'eⓔｅèéêềếễểẽēḕḗĕėëẻěȅȇẹệȩḝęḙḛɇɛǝ' }, { 'base': 'f', 'letters': 'fⓕｆḟƒꝼ' }, { 'base': 'g', 'letters': 'gⓖｇǵĝḡğġǧģǥɠꞡᵹꝿ' }, { 'base': 'h', 'letters': 'hⓗｈĥḣḧȟḥḩḫẖħⱨⱶɥ' }, { 'base': 'hv', 'letters': 'ƕ' }, { 'base': 'i', 'letters': 'iⓘｉìíîĩīĭïḯỉǐȉȋịįḭɨı' }, { 'base': 'j', 'letters': 'jⓙｊĵǰɉ' }, { 'base': 'k', 'letters': 'kⓚｋḱǩḳķḵƙⱪꝁꝃꝅꞣ' }, { 'base': 'l', 'letters': 'lⓛｌŀĺľḷḹļḽḻſłƚɫⱡꝉꞁꝇ' }, { 'base': 'lj', 'letters': 'ǉ' }, { 'base': 'm', 'letters': 'mⓜｍḿṁṃɱɯ' }, { 'base': 'n', 'letters': 'nⓝｎǹńñṅňṇņṋṉƞɲŉꞑꞥ' }, { 'base': 'nj', 'letters': 'ǌ' }, { 'base': 'o', 'letters': 'oⓞｏòóôồốỗổõṍȭṏōṑṓŏȯȱöȫỏőǒȍȏơờớỡởợọộǫǭøǿɔꝋꝍɵ' }, { 'base': 'oi', 'letters': 'ƣ' }, { 'base': 'ou', 'letters': 'ȣ' }, { 'base': 'oo', 'letters': 'ꝏ' }, { 'base': 'p', 'letters': 'pⓟｐṕṗƥᵽꝑꝓꝕ' }, { 'base': 'q', 'letters': 'qⓠｑɋꝗꝙ' }, { 'base': 'r', 'letters': 'rⓡｒŕṙřȑȓṛṝŗṟɍɽꝛꞧꞃ' }, { 'base': 's', 'letters': 'sⓢｓßśṥŝṡšṧṣṩșşȿꞩꞅẛ' }, { 'base': 't', 'letters': 'tⓣｔṫẗťṭțţṱṯŧƭʈⱦꞇ' }, { 'base': 'tz', 'letters': 'ꜩ' }, { 'base': 'u', 'letters': 'uⓤｕùúûũṹūṻŭüǜǘǖǚủůűǔȕȗưừứữửựụṳųṷṵʉ' }, { 'base': 'v', 'letters': 'vⓥｖṽṿʋꝟʌ' }, { 'base': 'vy', 'letters': 'ꝡ' }, { 'base': 'w', 'letters': 'wⓦｗẁẃŵẇẅẘẉⱳ' }, { 'base': 'x', 'letters': 'xⓧｘẋẍ' }, { 'base': 'y', 'letters': 'yⓨｙỳýŷỹȳẏÿỷẙỵƴɏỿ' }, { 'base': 'z', 'letters': 'zⓩｚźẑżžẓẕƶȥɀⱬꝣ' }];
            this.diacriticsMap = {};
            for (var i = 0; i < defaultDiacriticsRemovalap.length; i++) {
                var letters = defaultDiacriticsRemovalap[i].letters;
                for (var j = 0; j < letters.length; j++) {
                    this.diacriticsMap[letters[j]] = defaultDiacriticsRemovalap[i].base;
                }
            }
        }
    }]);

    return MaskAnalysis;
}(_dataStatisticsFrequencyMetrics2.default);

exports.default = MaskAnalysis;