"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * simple class that stores null/notNull in internal nullObject and handles the updates
 * nullObject is always accessible
 */

var NullMetrics = function () {
    /**
     * initialization with options
     * @param options
     * options:
     * elements: array of elements, any array that has appropriate number of elements
     * considerEmpty: whether empty string should be considered null
     */

    function NullMetrics() {
        var options = arguments.length <= 0 || arguments[0] === undefined ? { elements: [], considerEmpty: true } : arguments[0];

        _classCallCheck(this, NullMetrics);

        this.nullObject = this._createNullObject(options.elements || []);
        if (typeof options.considerEmpty !== "undefined") {
            this.considerEmpty = options.considerEmpty;
        } else {
            this.considerEmpty = true;
        }
    }

    _createClass(NullMetrics, [{
        key: "_createNullObject",
        value: function _createNullObject(elements) {
            return elements.map(function (element) {
                return { nullCount: { null: 0, nonNull: 0 } };
            });
        }
    }, {
        key: "checkNulls",


        /**
         * public method that should be called when you are "adding" new line of data (new data element)
         * @param fields object
         */
        value: function checkNulls(fields) {
            var _this = this;

            if (fields.length == this.nullObject.length) {
                this.nullObject = this.nullObject.map(function (nobj, index) {
                    if (fields[index].value == null || _this.considerEmpty && fields[index].value == "") {
                        return { nullCount: { null: nobj.nullCount.null + 1, nonNull: nobj.nullCount.nonNull } };
                    } else {
                        return { nullCount: { null: nobj.nullCount.null, nonNull: nobj.nullCount.nonNull + 1 } };
                    }
                });
            } else {
                console.error("NullMetrics: checked object does not have the same length as initialized Metrics, ignoring");
            }
        }
    }]);

    return NullMetrics;
}();

exports.default = NullMetrics;